DEBUG = False
triangle_templates = [
#    [ 0, 0, 0],
#    [ 1,-1, 1],
#    [ 1,-1, 0],
#    [ 1,-1,-1],
#    [-1,-1, 1],
#    [-1, 0, 1],
#    [-1, 1, 1],
#    [ 1, 1,-1],
#    [ 0, 1,-1],
#    [-1, 1,-1],
#    [ 1, 0,-1],
#    [-1, 1, 0],
#    [ 0,-1, 1],

#    [ 0, 0, 0],

#    [ 10,-10, 10],
#    [ 10,-10, 0],
#    [ 10,-10,-10],
#    [-10,-10, 10],
#    [-10, 0,  10],
#    [-10, 10, 10],
#    [ 10, 10,-10],
#    [ 0,  10,-10],
#    [-10, 10,-10],

    [ 10, 10,-10],
    [ 10, 0 ,-10],
    [ 10,-10,-10],
    [-10, 10,-10],
    [-10, 10, 0 ],
    [-10, 10, 10],
    [ 10,-10, 10],
    [ 0 ,-10, 10],
    [-10,-10, 10],
]
redstar_index = [2, 2, 2, 1, 1, 1, 0, 0, 0]

def adjust_D_bak(triangle, threshold):
    adjusted_data = []
    to_adjust = []
    for i, value in enumerate(triangle):
        if abs(value) < threshold:
            adjusted_data.append(0)
            to_adjust.append((i, value))
        elif value >= threshold:
            adjusted_data.append(10)
        elif value <= -threshold:
            adjusted_data.append(-10)
    to_adjust = sorted(to_adjust, key=lambda x: abs(x[1]), reverse=True)
    adjusted_value = []
    adjust_threshold = None 
    while adjusted_data not in triangle_templates:
        if len(to_adjust) == 0:
            raise Exception('Cannot adjust triangle: %s' % triangle)
        adjust_idx, adjust_threshold = to_adjust.pop(0)
        adjusted_data[adjust_idx] = 10 if adjust_threshold > 0 else -10
        adjusted_value.append((adjust_idx, adjust_threshold))
    return adjusted_value, adjusted_data 

def adjust_D(key, triangle, threshold, min_redstar, s2_record):
    adjusted_data = []
    to_adjust = []
    for i, value in enumerate(triangle):
#        if abs(value) < threshold:
#            adjusted_data.append(0)
#            to_adjust.append((i, value))
        if value > 0:
            adjusted_data.append(10)
        elif value < 0:
            adjusted_data.append(-10)
        else:
            raise ValueError('value is 0')
    if adjusted_data not in triangle_templates:
        raise Exception('Cannot adjust triangle: %s, %s' % (key, triangle))
    index = triangle_templates.index(adjusted_data)
    redstar_idx = redstar_index[index]


#    def add_s1_record(s2, tar, s1):
#        if (key[s2], key[tar]) not in s1_record:
#            s1_record[(key[s2], key[tar])] = []
#        s1_record[(key[s2], key[tar])].append(key[s1])
#    T = 0
#    A = 1
#    B = 2
#    if redstar_idx == 2:
#        add_s1_record(T, A, B)
#        add_s1_record(B, A, T)
#    elif redstar_idx == 1:
#        add_s1_record(T, B, A)
#        add_s1_record(A, B, T)
#    elif redstar_idx == 0:
#        add_s1_record(A, T, B)
#        add_s1_record(B, T, A)
    def add_s2_record(s1, tar, s2):
        if (key[s1], key[tar]) not in s2_record:
            s2_record[(key[s1], key[tar])] = []
        s2_record[(key[s1], key[tar])].append(key[s2])
    T = 0
    A = 1
    B = 2
    if redstar_idx == 2:
        add_s2_record(T, A, B)
        # add_s2_record(B, A, T)
    elif redstar_idx == 1:
        # add_s2_record(T, B, A)
        add_s2_record(A, B, T)
    elif redstar_idx == 0:
        # add_s2_record(A, T, B)
        add_s2_record(B, T, A)
    if DEBUG:
        print('------------------------------')
        print(key)
        print(triangle)

    min_redstar.append(abs(triangle[redstar_idx]))
    if abs(triangle[redstar_idx]) < threshold:
        adjusted_data[redstar_idx] = 0
    return None, adjusted_data, redstar_idx 

def get_adjusted_D_statistics(D_statistics, adjusted_D_values, triangles, A, B, C, f4, value, threshold, min_redstar, redstar_indices, key_visited, s2_record):
    key = tuple(sorted([A, B, C]))
    if key in key_visited: return
    pos = key.index(C)
    sign = 1 if (key.index(A) - pos) % 3 < (key.index(B) - pos) % 3 else -1
    value *= sign
    f4 *= sign
    # print(key, value)
    if key not in triangles:
        triangles[key] = {'D':[None, None, None], 'f4':[None, None, None]}
    triangles[key]['f4'][pos] = f4
    triangles[key]['D'][pos] = value

    if None not in triangles[key]['D']:
        key_visited.append(key)
        adjusted_value, adjusted_data, redstar_index = adjust_D(key, triangles[key]['D'], threshold, min_redstar, s2_record)
        redstar_indices[key] = redstar_index
#        if len(adjusted_value) > 0:
#            for idx, value in adjusted_value:
#                adjusted_D_values.append((key[idx], key[(idx+1)%3], key[(idx+2)%3], value))
        for i, value in enumerate(adjusted_data):
            # value == 0: record the original number
            if value == 0:
                D_statistics.append((key[(i+1)%3], key[(i+2)%3], key[i], value, triangles[key]['D'][i]))
            else:
                D_statistics.append((key[(i+1)%3], key[(i+2)%3], key[i], value, triangles[key]['D'][i]))
        print_key = key[:] + key[:1]
        # print(print_key, triangles[key], adjusted_data)
#        if key == ('Dushan', 'Longlin', 'Qihe'):
#            print(D_statistics)
        # del triangles[key]