import matplotlib.pyplot as plt
from sklearn.linear_model import LinearRegression
import numpy as np



populations = ['Kostenki14',
               'Tianyuan',
               'Boshan',
               'Qihe',
               'Longlin',
               'Dushan',
               'Baojianshan',
               'La368']

all_statistics = dict()
all_populations = set()
with open('data/UPA34_4.f4.AI.log') as f:
    for l in f.readlines():
        if not l.startswith('result'): continue
        A, B, C = l.split()[1:4]
        all_populations.add(A)
        all_populations.add(B)
        all_populations.add(C)
        value = float(l.split()[5])
        all_statistics[(A, B, C)] = value

test = 'Dushan'
R1 = 'Baojianshan'
x = []
y = [] 
print(all_populations)
for R2 in all_populations:
    if R2 != 'Qihe': continue
    for O1 in all_populations:
        if O1 in populations: continue
        if R2 == O1 or R1 == test or R2 == test or R1 == O1: continue
        y.append(all_statistics[(test, R1, O1)])
        x.append(all_statistics[(test, R2, O1)])
    
print(len(x))

plt.scatter(x, y)
plt.savefig('test.png')

x = np.array(x).reshape(-1, 1)
y = np.array(y).reshape(-1, 1)
model = LinearRegression()
model.fit(x, y)

print("k", model.coef_)
print("b", model.intercept_)
print("R2", model.score(x, y))